Index: /pjproject/trunk/third_party/build/portaudio/libportaudio.dsp
===================================================================
--- /pjproject/trunk/third_party/build/portaudio/libportaudio.dsp	(revision 1864)
+++ /pjproject/trunk/third_party/build/portaudio/libportaudio.dsp	(revision 1865)
@@ -43,5 +43,5 @@
 F90=df.exe
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\..\portaudio\src\common" /I "..\..\portaudio\include" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D "PA_ENABLE_DEBUG_OUTPUT" /D "_CRT_SECURE_NO_DEPRECATE" /D "PA_NO_ASIO" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\..\portaudio\src\common" /I "..\..\portaudio\include" /I "..\..\portaudio\src\os\win" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D "PA_ENABLE_DEBUG_OUTPUT" /D "_CRT_SECURE_NO_DEPRECATE" /D "PA_NO_ASIO" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
@@ -67,5 +67,5 @@
 F90=df.exe
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "..\..\portaudio\src\common" /I "..\..\portaudio\include" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D "PA_ENABLE_DEBUG_OUTPUT" /D "_CRT_SECURE_NO_DEPRECATE" /D "PA_NO_ASIO" /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "..\..\portaudio\src\common" /I "..\..\portaudio\include" /I "..\..\portaudio\src\os\win" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D "PA_ENABLE_DEBUG_OUTPUT" /D "_CRT_SECURE_NO_DEPRECATE" /D "PA_NO_ASIO" /YX /FD /GZ /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
@@ -170,4 +170,8 @@
 # Begin Source File
 
+SOURCE=..\..\portaudio\src\os\win\pa_win_waveformat.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\..\portaudio\src\os\win\pa_x86_plain_converters.c
 # End Source File
Index: /pjproject/trunk/third_party/build/portaudio/libportaudio.vcp
===================================================================
--- /pjproject/trunk/third_party/build/portaudio/libportaudio.vcp	(revision 1864)
+++ /pjproject/trunk/third_party/build/portaudio/libportaudio.vcp	(revision 1865)
@@ -882,9 +882,7 @@
 
 DEP_CPP_PA_AL=\
-	"..\..\portaudio\src\common\pa_allocation.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_AL=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_allocation.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -1155,11 +1153,9 @@
 
 DEP_CPP_PA_CO=\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_endianness.h"\
-	"..\..\portaudio\src\common\pa_types.h"\
-	
-NODEP_CPP_PA_CO=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_converters.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_endianness.h"\
+	"..\..\portaudio\src\common\pa_types.h"\
 	
 
@@ -1412,9 +1408,7 @@
 
 DEP_CPP_PA_CP=\
-	"..\..\portaudio\src\common\pa_cpuload.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_CP=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_cpuload.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2043,13 +2037,12 @@
 
 DEP_CPP_PA_FR=\
-	"..\..\portaudio\src\common\pa_endianness.h"\
-	"..\..\portaudio\src\common\pa_hostapi.h"\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	"..\..\portaudio\src\common\pa_trace.h"\
-	"..\..\portaudio\src\common\pa_types.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_FR=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_debugprint.h"\
+	"..\..\portaudio\src\common\pa_endianness.h"\
+	"..\..\portaudio\src\common\pa_hostapi.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
+	"..\..\portaudio\src\common\pa_trace.h"\
+	"..\..\portaudio\src\common\pa_types.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2348,11 +2341,9 @@
 
 DEP_CPP_PA_PR=\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_process.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_PR=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_converters.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_process.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2701,15 +2692,13 @@
 
 DEP_CPP_PA_SK=\
-	"..\..\portaudio\src\common\pa_allocation.h"\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_cpuload.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_hostapi.h"\
-	"..\..\portaudio\src\common\pa_process.h"\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_SK=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_allocation.h"\
+	"..\..\portaudio\src\common\pa_converters.h"\
+	"..\..\portaudio\src\common\pa_cpuload.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_hostapi.h"\
+	"..\..\portaudio\src\common\pa_process.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2974,8 +2963,6 @@
 
 DEP_CPP_PA_ST=\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	
-NODEP_CPP_PA_ST=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
 	
 
@@ -3314,4 +3301,5 @@
 
 DEP_CPP_PA_WI=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
 	"..\..\portaudio\include\pa_win_wmme.h"\
 	"..\..\portaudio\include\portaudio.h"\
@@ -3319,10 +3307,14 @@
 	"..\..\portaudio\src\common\pa_converters.h"\
 	"..\..\portaudio\src\common\pa_cpuload.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_hostapi.h"\
-	"..\..\portaudio\src\common\pa_process.h"\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	"..\..\portaudio\src\common\pa_trace.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
+	"..\..\portaudio\src\common\pa_debugprint.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_hostapi.h"\
+	"..\..\portaudio\src\common\pa_process.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
+	"..\..\portaudio\src\common\pa_trace.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
+	
+NODEP_CPP_PA_WI=\
+	"..\..\portaudio\src\hostapi\wmme\pa_win_wdmks_utils.h"\
 	
 
@@ -3795,4 +3787,179 @@
 	"..\..\portaudio\include\portaudio.h"\
 	"..\..\portaudio\src\common\pa_util.h"\
+	
+
+!ENDIF 
+
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\portaudio\src\os\win\pa_win_waveformat.c
+
+!IF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII_FP) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII_FP) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH4) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH4) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH3) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH3) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE emulator) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE emulator) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4I) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4I) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV_FP) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV_FP) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPS16) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPS16) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4T) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4T) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE x86) Release"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	
+
+!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE x86) Debug"
+
+DEP_CPP_PA_WIN_W=\
+	"..\..\portaudio\include\pa_win_waveformat.h"\
+	"..\..\portaudio\include\portaudio.h"\
 	
 
Index: /pjproject/trunk/third_party/build/portaudio/libportaudio.vcproj
===================================================================
--- /pjproject/trunk/third_party/build/portaudio/libportaudio.vcproj	(revision 1864)
+++ /pjproject/trunk/third_party/build/portaudio/libportaudio.vcproj	(revision 1865)
@@ -42,5 +42,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\..\portaudio\src\common,..\..\portaudio\include"
+				AdditionalIncludeDirectories="..\..\portaudio\src\common;..\..\portaudio\include;..\..\portaudio\src\os\win"
 				PreprocessorDefinitions="_DEBUG;WIN32;_LIB;PA_ENABLE_DEBUG_OUTPUT;_CRT_SECURE_NO_DEPRECATE;PA_NO_ASIO"
 				MinimalRebuild="true"
@@ -118,5 +118,5 @@
 				Optimization="2"
 				InlineFunctionExpansion="1"
-				AdditionalIncludeDirectories="..\..\portaudio\src\common,..\..\portaudio\include"
+				AdditionalIncludeDirectories="..\..\portaudio\src\common;..\..\portaudio\include;..\..\portaudio\src\os\win"
 				PreprocessorDefinitions="NDEBUG;WIN32;_LIB;PA_ENABLE_DEBUG_OUTPUT;_CRT_SECURE_NO_DEPRECATE;PA_NO_ASIO"
 				StringPooling="true"
@@ -505,4 +505,8 @@
 							/>
 						</FileConfiguration>
+					</File>
+					<File
+						RelativePath="..\..\portaudio\src\os\win\pa_win_waveformat.c"
+						>
 					</File>
 					<File
Index: /pjproject/trunk/third_party/build/portaudio/os-auto.mak.in
===================================================================
--- /pjproject/trunk/third_party/build/portaudio/os-auto.mak.in	(revision 1864)
+++ /pjproject/trunk/third_party/build/portaudio/os-auto.mak.in	(revision 1865)
@@ -48,5 +48,6 @@
 #
 ifeq ($(AC_PJMEDIA_SND),pa_darwinos)
-export PORTAUDIO_OBJS +=pa_mac_hostapis.o \
+#export PORTAUDIO_OBJS +=pa_mac_hostapis.o 
+export PORTAUDIO_OBJS += \
 			pa_unix_util.o \
 			pa_mac_core.o \