Index: pjproject/trunk/pjnath/build/pjturn_client.vcproj
===================================================================
--- pjproject/trunk/pjnath/build/pjstun_client.vcproj	(revision 1227)
+++ pjproject/trunk/pjnath/build/pjturn_client.vcproj	(revision 1867)
@@ -3,7 +3,7 @@
 	ProjectType="Visual C++"
 	Version="8.00"
-	Name="pjstun_client"
+	Name="pjturn_client"
 	ProjectGUID="{D13A6424-23A4-4990-998D-F80C63704580}"
-	RootNamespace="pjstun_client"
+	RootNamespace="pjturn_client"
 	>
 	<Platforms>
@@ -17,6 +17,6 @@
 		<Configuration
 			Name="Release|Win32"
-			OutputDirectory="./output/pjstun-client-i386-win32-vc8-release"
-			IntermediateDirectory="./output/pjstun-client-i386-win32-vc8-release"
+			OutputDirectory="./output/pjturn-client-i386-win32-vc8-release"
+			IntermediateDirectory="./output/pjturn-client-i386-win32-vc8-release"
 			ConfigurationType="1"
 			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC60.vsprops"
@@ -39,5 +39,5 @@
 			<Tool
 				Name="VCMIDLTool"
-				TypeLibraryName="./output/pjstun-client-i386-win32-vc8-release/pjstun_client.tlb"
+				TypeLibraryName="./output/pjturn-client-i386-win32-vc8-release/pjturn_client.tlb"
 				HeaderFileName=""
 			/>
@@ -51,8 +51,8 @@
 				RuntimeLibrary="2"
 				EnableFunctionLevelLinking="true"
-				PrecompiledHeaderFile="./output/pjstun-client-i386-win32-vc8-release/pjstun_client.pch"
-				AssemblerListingLocation="./output/pjstun-client-i386-win32-vc8-release/"
-				ObjectFile="./output/pjstun-client-i386-win32-vc8-release/"
-				ProgramDataBaseFileName="./output/pjstun-client-i386-win32-vc8-release/"
+				PrecompiledHeaderFile="./output/pjturn-client-i386-win32-vc8-release/pjturn_client.pch"
+				AssemblerListingLocation="./output/pjturn-client-i386-win32-vc8-release/"
+				ObjectFile="./output/pjturn-client-i386-win32-vc8-release/"
+				ProgramDataBaseFileName="./output/pjturn-client-i386-win32-vc8-release/"
 				BrowseInformation="1"
 				WarningLevel="3"
@@ -73,8 +73,8 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="netapi32.lib mswsock.lib ws2_32.lib odbc32.lib odbccp32.lib ole32.lib "
-				OutputFile="../bin/pjstun-client-i386-win32-vc8-release.exe"
+				OutputFile="../bin/pjturn-client-i386-win32-vc8-release.exe"
 				LinkIncremental="1"
 				SuppressStartupBanner="true"
-				ProgramDatabaseFile="./output/pjstun-client-i386-win32-vc8-release/pjstun-client-i386-win32-vc8-release.pdb"
+				ProgramDatabaseFile="./output/pjturn-client-i386-win32-vc8-release/pjturn-client-i386-win32-vc8-release.pdb"
 				SubSystem="1"
 				TargetMachine="1"
@@ -92,5 +92,5 @@
 				Name="VCBscMakeTool"
 				SuppressStartupBanner="true"
-				OutputFile="./output/pjstun-client-i386-win32-vc8-release/pjstun_client.bsc"
+				OutputFile="./output/pjturn-client-i386-win32-vc8-release/pjturn_client.bsc"
 			/>
 			<Tool
@@ -109,6 +109,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="./output/pjstun-client-i386-win32-vc8-debug"
-			IntermediateDirectory="./output/pjstun-client-i386-win32-vc8-debug"
+			OutputDirectory="./output/pjturn-client-i386-win32-vc8-debug"
+			IntermediateDirectory="./output/pjturn-client-i386-win32-vc8-debug"
 			ConfigurationType="1"
 			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC60.vsprops"
@@ -131,5 +131,5 @@
 			<Tool
 				Name="VCMIDLTool"
-				TypeLibraryName="./output/pjstun-client-i386-win32-vc8-debug/pjstun_client.tlb"
+				TypeLibraryName="./output/pjturn-client-i386-win32-vc8-debug/pjturn_client.tlb"
 				HeaderFileName=""
 			/>
@@ -142,8 +142,8 @@
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
-				PrecompiledHeaderFile="./output/pjstun-client-i386-win32-vc8-debug/pjstun_client.pch"
-				AssemblerListingLocation="./output/pjstun-client-i386-win32-vc8-debug/"
-				ObjectFile="./output/pjstun-client-i386-win32-vc8-debug/"
-				ProgramDataBaseFileName="./output/pjstun-client-i386-win32-vc8-debug/"
+				PrecompiledHeaderFile="./output/pjturn-client-i386-win32-vc8-debug/pjturn_client.pch"
+				AssemblerListingLocation="./output/pjturn-client-i386-win32-vc8-debug/"
+				ObjectFile="./output/pjturn-client-i386-win32-vc8-debug/"
+				ProgramDataBaseFileName="./output/pjturn-client-i386-win32-vc8-debug/"
 				BrowseInformation="1"
 				WarningLevel="3"
@@ -165,9 +165,9 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="netapi32.lib ws2_32.lib odbc32.lib odbccp32.lib ole32.lib "
-				OutputFile="../bin/pjstun-client-i386-win32-vc8-debug.exe"
+				OutputFile="../bin/pjturn-client-i386-win32-vc8-debug.exe"
 				LinkIncremental="2"
 				SuppressStartupBanner="true"
 				GenerateDebugInformation="true"
-				ProgramDatabaseFile="./output/pjstun-client-i386-win32-vc8-debug/pjstun-client-i386-win32-vc8-debug.pdb"
+				ProgramDatabaseFile="./output/pjturn-client-i386-win32-vc8-debug/pjturn-client-i386-win32-vc8-debug.pdb"
 				SubSystem="1"
 				TargetMachine="1"
@@ -185,5 +185,5 @@
 				Name="VCBscMakeTool"
 				SuppressStartupBanner="true"
-				OutputFile="./output/pjstun-client-i386-win32-vc8-debug/pjstun_client.bsc"
+				OutputFile="./output/pjturn-client-i386-win32-vc8-debug/pjturn_client.bsc"
 			/>
 			<Tool
@@ -209,5 +209,5 @@
 			>
 			<File
-				RelativePath="..\src\pjstun-client\client_main.c"
+				RelativePath="..\src\pjturn-client\client_main.c"
 				>
 				<FileConfiguration